﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Net.NetworkInformation;
using System.IO;
using System.Threading.Tasks;
using System.Threading;
using System.Runtime.InteropServices;
using System.Collections.Concurrent;

namespace FileSharingServer
{
    public partial class Form1 : Form
    {
        Thread t1;
        int flag = 0;
        string receivedPath = "yok";
        string fileName = "";
        public delegate void MyDelegate();
        string textoutputmsg = "";

        String wholecontent = String.Empty;

        public Form1()
        {
            InitializeComponent();
        }

        public class StateObject
        {
            // Client socket.
            public Socket workSocket = null;
            //Size of receive buffer.
            public const int BufferSize = 1024;
            // Receive buffer.
            public byte[] buffer = new byte[BufferSize];
        }

        public static ManualResetEvent allDone = new ManualResetEvent(false);
        public void StartListening()
        {
            byte[] bytes = new Byte[1024];
            IPEndPoint ipEnd = new IPEndPoint(IPAddress.Any, 8888);
            Socket listener = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);
            
            try
            {
                listener.Bind(ipEnd);
                listener.Listen(100);

                while (true)
                {
                    //Set the event to nonsignaled state.
                    allDone.Reset();

                    //Start an asynchronous socket to listen for connections.
                    listener.BeginAccept(new AsyncCallback(AcceptCallback), listener);
                    //Wait until a connection is made before continuing.
                    allDone.WaitOne();
                }
            }
            catch (Exception e)
            {
                MethodInvoker action = delegate { textBoxOutput.Text += e.ToString() + "\r\n"; };
                textBoxOutput.BeginInvoke(action);
            }

        }

        public void AcceptCallback(IAsyncResult ar)
        {
            //Signal the main thread to continue.
            allDone.Set();

            //Get the socket that handles the client request.
            Socket listener = (Socket)ar.AsyncState;
            Socket handler = listener.EndAccept(ar);

            //Create the state object.
            StateObject state = new StateObject();
            state.workSocket = handler;
            handler.BeginReceive(state.buffer, 0, StateObject.BufferSize, 0, new AsyncCallback(ReadCallback), state);
            flag = 0;
        }

        public void ReadCallback(IAsyncResult ar)
        {
            int fileNameLen = 1;
            String content = String.Empty;

            //Retrieve the state object and the handler socket from the asynchronous state object.
            StateObject state = (StateObject)ar.AsyncState;
            Socket handler = state.workSocket;
            int bytesRead = 0;
            try
            {
                //Read data from the client socket.
                bytesRead = handler.EndReceive(ar);
            }
            catch(Exception e)
            {
            }
            if (bytesRead > 0)
            {
                content = Encoding.ASCII.GetString(state.buffer, 0, bytesRead);
                wholecontent += content;
                
                if (content.IndexOf("DONE") > -1)
                {
                    byte[] tempbyte = Encoding.ASCII.GetBytes(wholecontent);
                    List<string> seperateddata = new List<string>();
                    List<string> filename = new List<string>();
                    List<int> filenamelen = new List<int>();
                    while (wholecontent.IndexOf("EOF") > -1)
                    {
                        seperateddata.Add(wholecontent.Substring(0, wholecontent.IndexOf("EOF") + 3));
                        wholecontent = wholecontent.Substring(wholecontent.IndexOf("EOF") + 3, wholecontent.Length - (wholecontent.IndexOf("EOF") + 3));
                    }

                    for (int i = 0; i < seperateddata.Count; i++)
                    {
                        byte[] tempbytes = Encoding.ASCII.GetBytes(seperateddata[i]);
                        filenamelen.Add(BitConverter.ToInt32(tempbytes, 0));
                        fileNameLen = BitConverter.ToInt32(tempbytes, 0);
                        fileName = Encoding.ASCII.GetString(tempbytes, 4, fileNameLen);
                        filename.Add(Encoding.ASCII.GetString(tempbytes, 4, fileNameLen));
                        receivedPath = "C:\\concorde\\" + fileName;
                        BinaryWriter writer = new BinaryWriter(File.Open(receivedPath, FileMode.Create));
                        writer.Write(tempbytes, 4 + fileNameLen, tempbytes.Length - (4 + fileNameLen));
                        writer.Close();
                    }

                    var results = new ConcurrentBag<double>();
                    Parallel.For(0, seperateddata.Count, k =>
                    {
                        //All the data has been read from the client.
                    System.Diagnostics.ProcessStartInfo psi = new System.Diagnostics.ProcessStartInfo("C:\\concorde\\concorde.exe");
                    psi.Arguments = " -x /cygdrive/c/concorde/" + filename[k];
                    //Calculate do something and reply with answer
                    psi.CreateNoWindow = true;
                    psi.RedirectStandardInput = true;
                    psi.RedirectStandardOutput = true;
                    psi.RedirectStandardError = true;
                    psi.UseShellExecute = false;
                    psi.WindowStyle = System.Diagnostics.ProcessWindowStyle.Hidden;

                    System.Diagnostics.Process cmdexe = new System.Diagnostics.Process();
                    cmdexe.StartInfo = psi;
                    List<string> myoutput = new List<string>();
                    double tourcost = 0;
                    while (tourcost == 0)
                    {
                        cmdexe.Start();
                        string output = cmdexe.StandardOutput.ReadToEnd();
                        cmdexe.WaitForExit();
                        while (!cmdexe.HasExited)
                        {

                        }
                        if (output.IndexOf("Optimal Solution:") > -1)
                        {
                            string output1 = output.Substring(output.IndexOf("Optimal Solution:") + 18);
                            string output2 = output1.Substring(0, output1.IndexOf("\n"));
                            tourcost = Convert.ToDouble(output2);
                        }
                        else
                        {
                            tourcost = 0;
                        }
                    }
                    results.Add(tourcost);
                    });
                    for (int i = 0; i < results.Count; i++)
                    {
                        System.IO.File.Delete("C:\\concorde\\" + filename[i]);
                        string deletepath = Path.GetDirectoryName(Application.ExecutablePath) + "\\" + filename[i].Substring(0, filename[i].Length - 4) + ".sol";
                        string deletepath1 = Path.GetDirectoryName(Application.ExecutablePath) + "\\" + filename[i].Substring(0, filename[i].Length - 4) + ".res";
                        string deletepath2 = Path.GetDirectoryName(Application.ExecutablePath) + "\\O" + filename[i].Substring(0, filename[i].Length - 4) + ".res";
                        System.IO.File.Delete(deletepath);
                        System.IO.File.Delete(deletepath1);
                        System.IO.File.Delete(deletepath2);
                    }
                    wholecontent = "";
                    textoutputmsg = "";
                    for (int i = 0; i < results.Count - 1; i++)
                    {
                        textoutputmsg += results.ElementAt(i).ToString() + ",";
                    }
                    textoutputmsg += results.ElementAt(results.Count - 1).ToString();
                    textoutputmsg += "EOF";
                    Send(handler, textoutputmsg);
                }
                else
                {
                    //Not all data received. Get more.
                    handler.BeginReceive(state.buffer, 0, StateObject.BufferSize, 0, new AsyncCallback(ReadCallback), state);
                }
            }
            else
            {
                //textoutputmsg = "Data has been received by this server.";
                //Invoke(new MyDelegate(LabelWriter));
                //MethodInvoker action = delegate { textBoxOutput.Text += "Data has been received by this server.\r\n"; };
                //textBoxOutput.BeginInvoke(action);
            }

        }

        public void Send(Socket handler, string data)
        {
            //Convert the string data to byte data using ASCII encoding.
            byte[] byteData = Encoding.ASCII.GetBytes(data);

            //Begin sending the data to the remote device.
            handler.BeginSend(byteData, 0, byteData.Length, 0, new AsyncCallback(SendCallback), handler);
        }

        public void SendCallback(IAsyncResult ar)
        {
            try
            {
                // Retrieve the socket from the state object.
                Socket handler = (Socket)ar.AsyncState;

                // Complete sending the data to the remote device.
                int bytesSent = handler.EndSend(ar);
                //Console.WriteLine("Sent {0} bytes to client.", bytesSent);
                MethodInvoker action = delegate { textBoxOutput.Text += "Sent " + bytesSent.ToString() + " bytes to client.\r\n"; };
                textBoxOutput.BeginInvoke(action);

                handler.Shutdown(SocketShutdown.Both);
                handler.Close();

            }
            catch (Exception e)
            {
                //Console.WriteLine(e.ToString());
                MethodInvoker action = delegate { textBoxOutput.Text += e.ToString() + "\r\n"; };
                textBoxOutput.BeginInvoke(action);
            }

        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            if (t1 != null)
            {
                t1.Abort();
            }
        }

        private void btnListen_Click(object sender, EventArgs e)
        {
            t1 = new Thread(new ThreadStart(StartListening));
            t1.Start();
        }

        private void buttonClear_Click(object sender, EventArgs e)
        {
            textBoxOutput.Text = "";
        }
    }
}